Set ANSI_NULLS ON
GO
Set QUOTED_IDENTIfIER OFF
GO

If EXISTS (Select * From sys.objects 
   Where object_id = OBJECT_ID(N'Pron_IngHE_Reserva') )
DROP PROCEDURE Pron_IngHE_Reserva
GO

Create  PROCEDURE Pron_IngHE_Reserva
                  @dia_inic datetime, 
                  @dia_fin datetime, 
                  @dia_reserv datetime, 
                  @mone int, 
                  @tasa_ext numeric(13,8)
AS

/* Fecha: 01 Mayo 2013  
   Calcula ingreso de Hospedaje en RESERVAS,
   dentro un rango de fechas a base,
   de la fecha de reservacion hacia el pasado 
*/

Begin

    Declare @Ing_Local numeric(15,2), 
            @mese varchar(10), 
            @ciclo datetime, 
            @ing_reserva numeric(15,2)
            
   Create Table #Tab_PREH
                (id_rese		int, 
				 id_cont		int,
				 id_estado		int,
				 id_mone		int,
				 tasa			numeric(13,8),
				 fecha_ent		datetime,
				 fecha_sal		datetime,
				 fecha_reserv	datetime,
				 cant_habi		int,
				 precio_hab		money,
				 precio			numeric(18,2),
				 cantidad		tinyint,
				 nombre			varchar(40),
				 nomb_reserv	varchar(40),
				 nro_reserva	int,
				 fecha_anulada	datetime,
				 id_lres		int,
				 id_ralo		int,
				 id_agen		int,
				 tasa_fija		numeric(13,8),
				 cod_mone		char(3))
     
/* CREA TABLA DE POSIBLES DATOS Pasado--Futuro */  
							
Insert into #Tab_PREH
Select rese.id_rese, rese.id_cont, 
       id_estado, cont.id_mone, tasa, 
       fecha_ent=reau.fecha_desde, 
       fecha_sal=reau.fecha_hasta, fecha_reserv, 
       cant_habi,precio_hab,
	   precio, cantidad, nombre ,nomb_reserv, 
	   nro_reserva, fecha_anulada, lres.id_lres, 
	   lres.id_ralo, id_agen, tasa_fija, cod_mone
   From hoterese rese
        Inner Join Hotelres lres on  rese.id_rese = lres.id_rese 
        Inner Join Hotecont cont on  rese.id_cont = cont.id_cont
        Inner join Hotereau reau on lres.id_lres = reau.id_lres        
        Inner Join Siclamon sicla on  cont.id_mone = sicla.id_mone
        Where DateDIff(day, rese.fecha_ent, @dia_inic) <= 0 
              and DateDIff(day, rese.fecha_ent, @dia_fin) >= 0 
              and rese.id_estado in(3,5)
              and reau.id_con0 
              in (Select thab.id_con0 
                     From hotethab thab )
  UNION
	Select rese.id_rese, rese.id_cont, 
		   id_estado, cont.id_mone, tasa,
		   fecha_ent=reau.fecha_desde, 
		   fecha_sal=reau.fecha_hasta, fecha_reserv,
		   cant_habi,precio_hab,
		   precio, cantidad, nombre ,nomb_reserv, 
		   nro_reserva, fecha_anulada, 
		   lres.id_lres, lres.id_ralo, id_agen, tasa_fija, cod_mone
  	   From HOTEHRES rese
			Inner Join HOTEHLRE lres on rese.id_rese = lres.id_rese 
			Inner Join Hotecont cont on rese.id_cont = cont.id_cont
			Inner join HOTEHREAU reau on lres.id_lres = reau.id_lres        
			Inner Join Siclamon  sicla on  cont.id_mone  = sicla.id_mone
	   Where DateDIff(day, rese.fecha_ent, @dia_inic) <= 0 
		     and DateDIff(day, rese.fecha_ent, @dia_fin) >= 0 
	         and rese.id_estado in(2,3,5)
			 and reau.id_con0 
			 in (Select thab.id_con0 
			        From hotethab thab )
 	   Order by fecha_reserv


/* CREA CONSULTA DATOS DE INGRESO DE HOSPEDAJE POR MES */  
																	
Set @mese = LEFT(year(@dia_inic),4) 
            + Right('0'+left(month(@dia_inic),2),2)

While @mese <= (LEFT(year(@dia_fin),4) 
               + Right('0'+left(month(@dia_fin),2),2)) 
  Begin 
 
	--Select @ciclo=LEFT(year(@dia_inic),4)+Right('0'+left(month(@dia_inic),2),2)+Right('0'+left(day(@dia_inic),2),2)
	Select @ciclo= (dateadd(d,-1,dateadd(m,1, 
	                CAST ((LEFT(year(LEFT(year(@dia_inic),4) 
	                       + Right('0'+left(month(@dia_inic),2),2) 
	                       + Right('0'+left(day(@dia_inic),2),2)),4)
				           + Right('0'+left(month(LEFT(year(@dia_inic),4)
				           + Right('0'+left(month(@dia_inic),2),2) 
				           + Right('0'+left(day(@dia_inic),2),2)),2),2)+'01') as smalldatetime))))
	 
	Set @ing_reserva=0
	While   @dia_inic <= @ciclo
		Begin
    
			Select @Ing_Local = Coalesce(@Ing_Local,0) 
			                   + Coalesce(Sum ( (precio*cantidad) 
			                   * Case When id_mone ! = @mone
                                      Then @tasa_ext / COALESCE(tasa_fija, tasa)
                                      Else 1 End ) ,0.00) 
					From #Tab_PREH
					Where DATEDIfF(DAY, @dia_reserv, fecha_reserv)<=0 
					      and DateDIff(day, fecha_ent, @dia_inic) >= 0 
					      and DateDIff(day, @dia_inic, fecha_sal) > 0
			
			Set @dia_inic=@dia_inic + 1  
			Set @ing_reserva = @ing_reserva +  Coalesce(@Ing_Local,0)
			Set @Ing_Local=0        
		End   	
		
/* CREA TABLA CON DATOS DE INGRESO DE HOSPEDAJE POR MES */ 
														 
	Update HOTEDAIPG 
	   Set ing_Reserva = Ing_Reserva + @ing_reserva
  	   Where mes=MONTH(@ciclo) 
  	        and fyear=YEAR(@ciclo)
									
	Set @dia_inic =@dia_inic  
	Set @mese = @mese + 1
	Set @mese=LEFT(year(@dia_inic),4)+Right('0'+left(month(@dia_inic),2),2)
	
  End 
End



