
/****** Object:  StoredProcedure [dbo].[DSS_INV_Consumos]    Script Date: 07/02/2013 13:53:14 ******/
SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO

DROP PROCEDURE [dbo].[DSS_INV_Consumos] 
GO

CREATE PROCEDURE [dbo].[DSS_INV_Consumos] 
				@cod_desde VARCHAR(20), 
				@cod_hasta VARCHAR(20), 
				--@list_alma VARCHAR(8000), 
				--@list_secc VARCHAR(8000), 
				@fdesde    DATETIME, 
				@fhasta    DATETIME, 
				@consumo   BIT,
				@resumido  BIT
AS

BEGIN

	-- GM: En vez de cantidad_d en compras, la calcul a partir
	-- de cantidad porque por un error en las actualizaciones de compras y
	-- traslados, no se actualiza la cantidad_d en todos los casos y de dejarlo as,
	-- las operaciones ya hechas nunca daran bien.

    -- sp que devuelve el CURSOR para el reporte Consumo Global Productos
    -- las cantidades van en um de almacen
    -- no se puede tomar nada del submayor (salvo inv.inic., cambios de cod y de um),
    -- porque se perderian los consumos hacia secciones de gasto, de insumos, de NCE, etc

	-- Ver en Constotqi, los casos q se consideran consumo.
	-- Aqui se seleccionan los datos para las otras columnas del reporte. Solo
	-- no se incluyen aqui las rebajas, invent y aj neg, porque solo se cuentan
	-- en los consumos. Ni se incluyen los traslados porque este consumo es 
	-- global de la entidad, por lo q solo influyen, de traslado, lo que
	-- es consumo que ya sale por ah.El resto de las cosas de consumo, 
	-- se cuenta en consumo y aqui (entrada-consumo)

    DECLARE @Cad                   VARCHAR(8000),
	     	@filtro_arti           VARCHAR(8000),
	        @filtro_destino        VARCHAR(8000),
	        @filtro_destino_multi  VARCHAR(8000),
	        @filtro_destino_multi1 VARCHAR(8000),
	        @filtro_destino_elab   VARCHAR(8000),
			@revertido             INT

    -- Preparo los parmetros
    SELECT @filtro_arti = ''
    IF @cod_desde IS NOT NULL AND @cod_hasta IS NOT NULL
        SELECT @filtro_arti = ' AND arti.FullArtiCode BETWEEN "' + @cod_desde 
                              + '" AND "' + @cod_hasta + '" '
    ELSE
    BEGIN 
        IF @cod_desde IS NOT NULL
            SELECT @filtro_arti = ' AND arti.FullArtiCode >= "' + @cod_desde + '" '
        ELSE
            IF @cod_hasta IS NOT NULL
                SELECT @filtro_arti = ' AND arti.FullArtiCode <= "' + @cod_hasta + '" '
    END

    SELECT @filtro_destino        = '', 
           @filtro_destino_multi  = '', 
           @filtro_destino_multi1 = '', 
           @filtro_destino_elab   = ''
		           
 --   IF @list_alma = ''
 --       SELECT @list_alma=NULL
 --   IF @list_secc = ''
 --       SELECT @list_secc=NULL

 --   IF @list_alma IS NOT NULL AND @list_secc IS NOT NULL
 --       SELECT @filtro_destino        = ' AND (smay.id_alma  IN (' + @list_alma + ') OR smay.id_secc  IN (' + @list_secc + ')) ',
	--	       @filtro_destino_elab   = ' AND  smay.id_secc  IN (' + @list_secc + ') ',
	--	       @filtro_destino_multi  = ' AND (smay.id_almad IN (' + @list_alma + ') OR smay.id_seccd IN (' + @list_secc + ')) ',
	--	       @filtro_destino_multi1 = ' AND (smay.id_almao IN (' + @list_alma + ') OR smay.id_secco IN (' + @list_secc + ')) '
	--ELSE
	--BEGIN 
	--	IF @list_alma IS NOT NULL
	--		SELECT  @filtro_destino        = ' AND smay.id_alma  IN (' + @list_alma + ') ',
	--				@filtro_destino_multi  = ' AND smay.id_almad IN (' + @list_alma + ') ',
	--				@filtro_destino_multi1 = ' AND smay.id_almao IN (' + @list_alma + ') '
	--	ELSE
	--		IF @list_secc IS NOT NULL
	--			SELECT @filtro_destino        = ' AND smay.id_secc  IN (' + @list_secc + ') ',
	--				   @filtro_destino_elab   = ' AND smay.id_secc  IN (' + @list_secc + ') ',
	--				   @filtro_destino_multi  = ' AND smay.id_seccd IN (' + @list_secc + ') ',
	--				   @filtro_destino_multi1 = ' AND smay.id_secco IN (' + @list_secc + ') '
	--END

	-- Crear tabla temporal
	CREATE TABLE #invactual 
			   (id_alma   INT, 
				id_secc   INT,
				id_arti   INT, 
				cod_arti  VARCHAR(100),
				desc_arti VARCHAR(100),
				cantidad  NUMERIC(18,4),
				importe   NUMERIC(18,2),
				id_dmov   INT, 
				fec_oper  DATETIME,  
				id_unme   INT,
				cant_um   NUMERIC(18,4) )

	-- Crear tabla temporal para saldos anteriores por arti 
	CREATE TABLE #saldosant 
				(id_arti       INT, 
				 sant_cantidad NUMERIC(18,4),
				 sant_importe  NUMERIC(18,2))

	-- Crear tabla temporal para consumos por arti 
	CREATE TABLE #consumos 
				(id_arti   INT, 
				 cons_cant NUMERIC(18,4),
				 cons_imp  NUMERIC(18,2))

    -- Inventario Inicial (solo puede tomarse del submayor)
    SELECT @Cad  = 'INSERT #invactual 
		            SELECT smay.id_alma, 
		                   smay.id_secc, 
		                   smay.id_arti, 
			               cod_arti  = arti.FullArtiCode, 
			               desc_arti = arti.descripcion,
			               cantidad  = CONVERT(NUMERIC(18, 4),
					       COALESCE(CASE WHEN smay.id_alma IS NOT NULL THEN sini.cantidad 
										 ELSE ROUND(sini.cantidad / arti.cant_unme_se, 4) 
										 END, 0)),
			               importe = CONVERT(NUMERIC(18, 2), COALESCE(sini.importe, 0)),
			               smay.id_dmov, 
			               smay.fec_oper,  
			               id_unme = arti.id_unme_al,
			               cant_um = arti.cant_unme_al 
		            FROM       stoksmay smay
			        INNER JOIN stoksini sini ON sini.id_smay = smay.id_smay
			        INNER JOIN stokarti arti ON smay.id_arti = arti.id_arti
		            WHERE smay.id_dmov = 0 ' + @filtro_arti + @filtro_destino

	EXECUTE (@CAD)

	-- Compras
    SELECT @Cad = 'INSERT #invactual 
	               SELECT smay.id_alma, 
	                      smay.id_secc, 
	                      cmpl.id_arti, 
					      cod_arti  = arti.FullArtiCode, 
					      desc_arti = arti.descripcion,
					      cantidad  = COALESCE(cmpl.cantidad * cant_unme_al, 0),
					      importe   = COALESCE(cmpl.importe,0) + COALESCE(cmpl.imp_desgaste, 0),
					      id_dmov   = 1, 
					      oper.fec_oper,  
					      id_unme   = arti.id_unme_al,
					      cant_um   = arti.cant_unme_al
				   FROM       stokcmpi smay
				   INNER JOIN STOKOPER oper ON smay.id_operacion = oper.id_operacion
				   INNER JOIN stokcmpl cmpl ON smay.id_cmpi = cmpl.id_cmpi
				   INNER JOIN stokarti arti ON cmpl.id_arti = arti.id_arti 
				   WHERE oper.estado = 2 ' + @filtro_arti + @filtro_destino 

	EXECUTE (@CAD)

	-- Reversiones de Compras
    SELECT @Cad = 'INSERT #invactual 
	               SELECT smay.id_alma, 
	                      smay.id_secc, 
	                      cmpl.id_arti, 
		                  cod_arti  = arti.FullArtiCode, 
		                  desc_arti = arti.descripcion,
		                  cantidad  = COALESCE(-cmpl.cantidad * cant_unme_al, 0),
		                  importe   = COALESCE(-cmpl.importe, 0) + COALESCE(-cmpl.imp_desgaste, 0),
		                  id_dmov   = 2, 
		                  rvtdor.fec_oper,  
		                  id_unme   = arti.id_unme_al ,
						  cant_um   = arti.cant_unme_al
				   FROM       stokcmpi smay
				   INNER JOIN STOKOPER oper   ON smay.id_operacion = oper.id_operacion
				   INNER JOIN STOKOPER rvtdor ON rvtdor.id_revertido = oper.id_operacion
			    -- INNER JOIN stokscmp scmp   ON scmp.id_smay = smay.id_smay
				   INNER JOIN stokcmpl cmpl   ON smay.id_cmpi = cmpl.id_cmpi 
				   INNER JOIN stokarti arti   ON cmpl.id_arti = arti.id_arti
				   WHERE cmpl.id_revertidor = rvtdor.id_operacion AND rvtdor.estado = 2 ' + @filtro_arti + @filtro_destino 

	EXECUTE (@CAD)

	-- Devoluciones
    SELECT @Cad = 'INSERT #invactual 
	               SELECT smay.id_alma, 
	                      smay.id_secc, 
	                      cmpl.id_arti, 
		                  cod_arti  = arti.FullArtiCode, 
						  desc_arti = arti.descripcion,
						  cantidad  = COALESCE(-cmpl.cantidad, 0),
						  importe   = COALESCE(-cmpl.importe, 0) + COALESCE(-cmpl.imp_desgaste, 0),
						  id_dmov   = 320, 
						  oper.fec_oper,  
						  id_unme   = arti.id_unme_al,
						  cant_um   = arti.cant_unme_al
				   FROM       stokdevi smay
				   INNER JOIN STOKOPER oper ON smay.id_operacion = oper.id_operacion
				   INNER JOIN stokdevl cmpl ON smay.id_devi = cmpl.id_devi
				   INNER JOIN stokarti arti ON cmpl.id_arti = arti.id_arti 
				   WHERE oper.estado = 2 ' + @filtro_arti + @filtro_destino 

	EXECUTE (@CAD)

	-- Ajustes positivos (los negativos van por cosumo)
    SELECT @Cad = 'INSERT #invactual 
	               SELECT smay.id_alma, 
	                      smay.id_secc, 
	                      ajul.id_arti,
		                  cod_arti  = arti.FullArtiCode, 
		                  desc_arti = arti.descripcion,
		                  cantidad  = COALESCE(CASE WHEN smay.id_alma IS NOT NULL THEN ajul.cantidad 
								                    ELSE ROUND(ajul.cantidad/arti.cant_unme_se, 4) 
								                    END, 0),
		                  importe   = COALESCE(ajul.importe, 0), 
						  id_dmov   = 5, 
						  oper.fec_oper,  
						  id_unme   = arti.id_unme_al,
						  cant_um   = arti.cant_unme_al
				   FROM       stokajuc smay
				   INNER JOIN stokajul ajul ON smay.id_operacion = ajul.id_operacion
				   INNER JOIN stokarti arti ON arti.id_arti = ajul.id_arti
				   INNER JOIN STOKOPER oper ON smay.id_operacion = oper.id_operacion
				   WHERE oper.estado=2 AND ajul.importe > 0 ' + @filtro_arti + @filtro_destino 

	EXECUTE (@CAD)     

	--Reversiones de Ajustes positivos (los negativos van por consumo)
    SELECT @Cad = 'INSERT #invactual 
	               SELECT smay.id_alma, 
	                      smay.id_secc, 
	                      ajul.id_arti,
						  cod_arti  = arti.FullArtiCode, 
						  desc_arti = arti.descripcion,
						  cantidad  = COALESCE(CASE WHEN smay.id_alma IS NOT NULL THEN -ajul.cantidad 
												    ELSE -ROUND(ajul.cantidad/arti.cant_unme_se, 4) 
												    END, 0),
						  importe   = COALESCE(-ajul.importe, 0), 
						  id_dmov   = 6, 
						  rvtdor.fec_oper,  
						  id_unme   = arti.id_unme_al,
						  cant_um   = arti.cant_unme_al 
				   FROM       stokajuc smay
				   INNER JOIN STOKOPER oper   ON smay.id_operacion   = oper.id_operacion
				   INNER JOIN STOKOPER rvtdor ON rvtdor.id_revertido = oper.id_operacion
				   INNER JOIN stokajul ajul   ON smay.id_operacion = ajul.id_operacion
				   INNER JOIN stokarti arti   ON ajul.id_arti = arti.id_arti
				   WHERE ajul.importe > 0 AND ajul.id_revertidor = rvtdor.id_operacion
			      	     AND rvtdor.estado = 2 ' + @filtro_arti + @filtro_destino 
     
    EXECUTE(@Cad)

	-- Fijacin de inventarios positivos (los negativos van por consumo)
    SELECT @Cad  = 'INSERT #invactual 
	                SELECT smay.id_alma, 
	                       smay.id_secc, 
	                       invl.id_arti,
		                   cod_arti  = arti.FullArtiCode, 
		                   desc_arti = arti.descripcion,
		                   cantidad  = COALESCE(CASE WHEN smay.id_alma IS NOT NULL THEN invl.toma-invl.existencia 
								                     ELSE ROUND((invl.toma-invl.existencia) / arti.cant_unme_se, 4) 
								                     END, 0),
						   importe   = COALESCE(invl.importe, 0),
						   id_dmov   = 9, 
						   oper.fec_oper,  
						   id_unme   = arti.id_unme_al,
						   cant_um   = arti.cant_unme_al
					FROM       stokinvc smay
					INNER JOIN stokinvl invl ON smay.id_operacion = invl.id_operacion
					INNER JOIN stokarti arti ON invl.id_arti = arti.id_arti
					INNER JOIN STOKOPER oper ON smay.id_operacion = oper.id_operacion
					WHERE oper.estado = 2 AND toma - existencia > 0 ' + @filtro_arti + @filtro_destino 
    
	EXECUTE (@CAD)

	-- Despieces resultantes 
    SELECT @Cad  = 'INSERT #invactual 
					SELECT smay.id_alma, 
					       smay.id_secc, 
					       desl.id_arti,
						   cod_arti  = arti.FullArtiCode, 
						   desc_arti = arti.descripcion,
						   cantidad  = COALESCE(CASE WHEN smay.id_alma IS NOT NULL THEN desl.cantidad 
												     ELSE ROUND(desl.cantidad/arti.cant_unme_se,4) 
												     END, 0),
						   importe   = COALESCE(desl.importe, 0.00),
						   id_dmov   = 102, 
						   oper.fec_oper,  
						   id_unme   = arti.id_unme_al,
						   cant_um   = arti.cant_unme_al
					FROM       stokdesc smay
					INNER JOIN stokdesl desl ON desl.id_operacion = smay.id_operacion
					INNER JOIN stokarti arti ON desl.id_arti = arti.id_arti
					INNER JOIN STOKOPER oper ON smay.id_operacion = oper.id_operacion
					WHERE oper.estado = 2 ' +  @filtro_arti + @filtro_destino 

	EXECUTE (@CAD)

	-- Reversiones de Despieces resultantes
    SELECT @Cad  = 'INSERT #invactual 
					SELECT smay.id_alma, 
					       smay.id_secc, 
					       desl.id_arti,
						   cod_arti  = arti.FullArtiCode, 
						   desc_arti = arti.descripcion,
						   cantidad  = COALESCE(CASE WHEN smay.id_alma IS NOT NULL THEN -desl.cantidad 
												     ELSE -ROUND(desl.cantidad/arti.cant_unme_se, 4) 
												     END, 0),
						   importe   = COALESCE(-desl.importe, 0.00),
						   id_dmov   = 112, 
						   rvtdor.fec_oper,  
						   id_unme   = arti.id_unme_al,
						   cant_um   = arti.cant_unme_al
					FROM       stokdesc smay
					INNER JOIN STOKOPER oper   ON smay.id_operacion = oper.id_operacion
					INNER JOIN STOKOPER rvtdor ON rvtdor.id_revertido = oper.id_operacion
					INNER JOIN stokdesl desl   ON desl.id_operacion = smay.id_operacion
					INNER JOIN stokarti arti   ON desl.id_arti = arti.id_arti
					WHERE rvtdor.estado=2 ' + @filtro_arti + @filtro_destino 

	EXECUTE (@CAD)

	-- Despieces origenes
    SELECT @Cad  = 'INSERT #invactual 
					SELECT smay.id_alma, 
					       smay.id_secc, 
					       smay.id_arti,
						   cod_arti  = arti.FullArtiCode, 
						   desc_arti = arti.descripcion,
						   cantidad  = COALESCE(CASE WHEN smay.id_alma IS NOT NULL THEN smay.cantidad 
												     ELSE ROUND(smay.cantidad/arti.cant_unme_se, 4) 
												     END, 0),
						   importe   = COALESCE(smay.importe, 0.00),
						   id_dmov   = 101, 
						   oper.fec_oper,  
						   id_unme   = arti.id_unme_al,
						   cant_um   = arti.cant_unme_al
					FROM       stokdesc smay
					INNER JOIN stokarti arti ON smay.id_arti = arti.id_arti
					INNER JOIN STOKOPER oper ON smay.id_operacion = oper.id_operacion
					WHERE oper.estado = 2 ' +  @filtro_arti + @filtro_destino 

	EXECUTE (@CAD)

	-- Reversiones de Despieces origenes
    SELECT @Cad  = 'INSERT #invactual 
					SELECT smay.id_alma, 
					       smay.id_secc, 
					       smay.id_arti,
						   cod_arti  = arti.FullArtiCode, 
						   desc_arti = arti.descripcion,
						   cantidad  = COALESCE(CASE WHEN smay.id_alma IS NOT NULL THEN -smay.cantidad 
												     ELSE ROUND(-smay.cantidad / arti.cant_unme_se, 4) 
												     END, 0),
						   importe   = COALESCE(-smay.importe, 0.00),
						   id_dmov   = 111, 
						   rvtdor.fec_oper,  
						   id_unme   = arti.id_unme_al,
						   cant_um   = arti.cant_unme_al
					FROM       stokdesc smay
					INNER JOIN STOKOPER oper   ON smay.id_operacion = oper.id_operacion
					INNER JOIN STOKOPER rvtdor ON rvtdor.id_revertido = oper.id_operacion
					INNER JOIN stokarti arti   ON smay.id_arti = arti.id_arti
					WHERE rvtdor.estado = 2 ' + @filtro_arti + @filtro_destino 

	EXECUTE (@CAD)

	-- Cambio de cdigo destino, lo tomo del submayor porque en este movimiento todo lo que existe
	-- tiene que estar aqu.
    SELECT @Cad  = 'INSERT #invactual 
					SELECT smay.id_alma, 
					       smay.id_secc, 
					       smay.id_arti,
						   cod_arti  = arti.FullArtiCode, 
						   desc_arti = arti.descripcion,
						   cantidad  = COALESCE(CASE WHEN smay.id_alma IS NOT NULL THEN camr.cantidad 
												     ELSE ROUND(camr.cantidad / arti.cant_unme_se, 4) 
												     END, 0),
						   importe   = COALESCE(camr.importe, 0),
						   id_dmov   = 131, 
						   smay.fec_oper,  
						   id_unme   = arti.id_unme_al,
						   cant_um   = arti.cant_unme_al
					FROM       stoksmay smay
					INNER JOIN stokscmr scmr ON scmr.id_smay = smay.id_smay
					INNER JOIN stokcamr camr ON scmr.id_camr = camr.id_camr
					INNER JOIN stokarti arti ON smay.id_arti = arti.id_arti
					INNER JOIN STOKOPER oper ON smay.id_operacion = oper.id_operacion
					WHERE 0 = 0 ' + @filtro_arti + @filtro_destino 
     
	EXECUTE (@CAD)

	-- Cambio de cdigo orgenes, lo tomo del submayor porque en este movimiento todo lo que existe
	-- tiene que estar aqu.
    SELECT @Cad  = 'INSERT #invactual 
					SELECT smay.id_alma, 
					       smay.id_secc, 
					       smay.id_arti,
						   cod_arti  = arti.FullArtiCode, 
						   desc_arti = arti.descripcion,
						   cantidad  = COALESCE(CASE WHEN smay.id_alma IS NOT NULL THEN carl.cantidad 
												     ELSE ROUND(carl.cantidad / arti.cant_unme_se, 4) 
												     END, 0),
						   importe   = COALESCE(carl.importe, 0),
						   id_dmov   = 132, 
						   smay.fec_oper,  
						   id_unme   = arti.id_unme_al,
						   cant_um   = arti.cant_unme_al
					FROM       stoksmay smay
					INNER JOIN stokscml scml ON scml.id_smay = smay.id_smay
					INNER JOIN stokcarl carl ON scml.id_carl = carl.id_carl
					INNER JOIN stokarti arti ON smay.id_arti = arti.id_arti
					INNER JOIN STOKOPER oper ON smay.id_operacion = oper.id_operacion
					WHERE 0 = 0 ' + @filtro_arti + @filtro_destino 

	EXECUTE (@CAD)

	-- Cambios de UM, orgenes y destinos, desde el submayor que es donde nico existen
    SELECT @Cad  = 'INSERT #invactual 
					SELECT smay.id_alma, 
					       smay.id_secc, 
					       smay.id_arti,
						   cod_arti  = arti.FullArtiCode, 
						   desc_arti = arti.descripcion,
						   cantidad  = COALESCE(CASE WHEN smay.id_alma IS NOT NULL THEN scmu.cantidad 
												     ELSE ROUND(scmu.cantidad / arti.cant_unme_se, 4) 
												     END, 0),
						   importe   = COALESCE(scmu.importe, 0),
						   smay.id_dmov, 
						   smay.fec_oper,  
						   id_unme   = arti.id_unme_al,
						   cant_um   = arti.cant_unme_al 
					FROM       stoksmay smay
					INNER JOIN stokscmu scmu ON scmu.id_smay = smay.id_smay
					INNER JOIN stokarti arti ON smay.id_arti = arti.id_arti
					INNER JOIN STOKOPER oper ON smay.id_operacion = oper.id_operacion
					WHERE 0 = 0 ' + @filtro_arti + @filtro_destino 

      EXECUTE(@Cad)

	--Traslados multialmacen recibidos
    SELECT @Cad  = 'INSERT #invactual 
					SELECT smay.id_almad, 
					       smay.id_seccd, 
					       tral.id_arti,
						   cod_arti  = arti.FullArtiCode, 
						   desc_arti = arti.descripcion,
						   cantidad  = COALESCE(CASE WHEN smay.id_almaO IS NOT NULL THEN tral.cantidad 
												     ELSE ROUND(tral.cantidad / arti.cant_unme_se, 4) 
												     END, 0),
						   importe   = COALESCE(tral.importe, 0),
						   id_dmov   = 72, 
						   oper.fec_oper,  
						   id_unme   = arti.id_unme_al,
						   cant_um   = arti.cant_unme_al
					FROM       stokmalc smay
					INNER JOIN stokmall tral ON smay.id_operacion = tral.id_operacion
					INNER JOIN stokarti arti ON tral.id_arti = arti.id_arti
					INNER JOIN STOKOPER oper ON smay.id_operacion = oper.id_operacion
					WHERE oper.estado = 2 AND smay.id_dato_de = dbo.GetCurrentDato() ' + @filtro_arti + @filtro_destino_multi 

	EXECUTE (@CAD)     

	--Traslados multialmacen enviados
    SELECT @Cad  = 'INSERT #invactual 
					SELECT smay.id_almad, 
					       smay.id_seccd, 
					       tral.id_arti,
						   cod_arti  = arti.FullArtiCode, 
						   desc_arti = arti.descripcion,
						   cantidad  = COALESCE(CASE WHEN smay.id_almaD IS NOT NULL THEN tral.cantidad 
												     ELSE ROUND(tral.cantidad / arti.cant_unme_se, 4) 
												     END,0),
						   importe   = COALESCE(tral.importe + tral.imp_desgaste, 0),
						   id_dmov   = 71, 
						   oper.fec_oper,  
						   id_unme   = arti.id_unme_al,
						   cant_um   = arti.cant_unme_al
					FROM       stokmalc smay
					INNER JOIN stokmall tral ON smay.id_operacion = tral.id_operacion
					INNER JOIN stokarti arti ON tral.id_arti = arti.id_arti
					INNER JOIN STOKOPER oper ON smay.id_operacion = oper.id_operacion
					WHERE oper.estado = 2 AND smay.id_dato_or = dbo.GetCurrentDato() ' + @filtro_arti + @filtro_destino_multi1 

	EXECUTE (@CAD)     

	-- Elaboraciones, hacer temporal con los ingredientes
	-- efectivamente rebajados
	SELECT o.id_operacion,
	       o.fec_oper,
	       o.id_tmov,
		   o.consecutivo,
		   o.referencia
	INTO #oper
	FROM       STOKOPER o 
	INNER JOIN stoktmov tm ON o.id_tmov = tm.id_tmov
	WHERE o.estado = 2 AND tm.id_cmov = 15	
	  AND (
		  (    @FDESDE IS NULL 
		   AND @FHASTA IS NOT NULL 
		   AND FEC_OPER <= @FHASTA) 
      OR
		  (    @FDESDE IS NOT NULL 
		   AND @FHASTA IS NULL 
		   AND FEC_OPER >= @FDESDE) 
	  OR
		  (    @FDESDE IS NOT NULL 
		   AND @FHASTA IS NOT NULL 
		   AND FEC_OPER BETWEEN @FDESDE AND @FHASTA)
	)
	IF @@ROWCOUNT != 0
	BEGIN		
	    -- hay elaboraciones 
		-- temporal para insertar las lneas de ingredientes
		CREATE TABLE #ingred 
					(id_operacion INT,
					 id_eell      INT, 
					 id_arti      INT,
					 cant_r       NUMERIC(18,4),
					 costo        NUMERIC(18,4),
					 importe      NUMERIC(18,4),
					 id_sub       INT)							

		DECLARE @operant INT, @minoper INT
		SELECT @operant = -1
		-- ciclo para llenar la tabla de ingredientes
		WHILE 1=1
		BEGIN
			SELECT @minoper = MIN(id_operacion) 
			FROM   #oper
			WHERE  id_operacion > @operant
			IF @minoper IS NULL
				BREAK
			INSERT #ingred 
			   EXECUTE GetLineasElaboracion @minoper
			SELECT @operant = @minoper
			CONTINUE				
		END
		-- elaborados
		SELECT @Cad  = 'INSERT #invactual 
						SELECT NULL, 
						       smay.id_secc, 
						       smay.id_arti,
							   cod_arti  = arti.FullArtiCode, 
							   desc_arti = arti.descripcion,
							   cantidad  = COALESCE(ROUND(smay.cant_r / arti.cant_unme_se, 4), 0),
							   importe   = COALESCE(smay.importe, 0.00),
							   id_dmov   = 152, 
							   oper.fec_oper,  
							   id_unme   = arti.id_unme_al,
							   cant_um   = arti.cant_unme_al
						FROM       STOKEELO smay 
						INNER JOIN #OPER    oper ON oper.ID_OPERACION = smay.ID_OPERACION 
						INNER JOIN STOKARTI arti ON arti.id_arti = smay.id_arti
						WHERE 1 = 1 '  +  @filtro_arti + @filtro_destino_elab
		EXECUTE (@CAD)     

		-- ingredientes 
	    SELECT @Cad  = 'INSERT #invactual 
						SELECT NULL, 
						       smay.id_secc, 
						       desl.id_arti,
							   cod_arti  = arti.FullArtiCode, 
							   desc_arti = arti.descripcion,
							   cantidad  = COALESCE(ROUND(desl.cant_r / arti.cant_unme_se, 4), 0),
							   importe   = COALESCE(desl.importe, 0.00),
							   id_dmov   = 151, oper.fec_oper,  
							   id_unme   = id_unme_al,
							   cant_um   = cant_unme_al
						FROM STOKEELO smay 
						INNER JOIN #ingred desl ON desl.id_operacion = smay.id_operacion
						INNER JOIN #OPER oper ON oper.ID_OPERACION = smay.ID_OPERACION 
						INNER JOIN STOKARTI arti ON arti.id_arti = desl.id_arti
						WHERE 1=1 '  +  @filtro_arti + @filtro_destino_elab
		EXECUTE (@CAD)
		DROP TABLE #ingred
	END		
	
	-- hay elaboraciones
	DROP TABLE #oper
	
	-- Reversion de elaboraciones, hacer un temporal con los ingredientes
	-- efectivamente rebajados
	SELECT o.id_operacion,
	       o.fec_oper,
	       o.id_tmov,
		   o.consecutivo,
		   o.referencia, 
		   o.id_revertido
	INTO #operrev
	FROM       STOKOPER o 
	INNER JOIN stoktmov tm ON o.id_tmov = tm.id_tmov
	WHERE o.estado = 2 
	  AND tm.id_cmov = 16 
	  AND (
		  (    @FDESDE IS NULL 
		   AND @FHASTA IS NOT NULL 
		   AND FEC_OPER <= @FHASTA) 
	  OR
	  	  (    @FDESDE IS NOT NULL 
	  	   AND @FHASTA IS NULL 
	  	   AND FEC_OPER >= @FDESDE) 
	  OR
	 	  (    @FDESDE IS NOT NULL 
	 	   AND @FHASTA IS NOT NULL 
	 	   AND FEC_OPER BETWEEN @FDESDE AND @FHASTA))
			
	IF @@ROWCOUNT != 0
	BEGIN		
	    -- hay reversion de elaboraciones 
		-- temporal para insertar las lneas de ingredientes
		CREATE TABLE #ingredrev 
					(id_operacion INT,
					 id_eell      INT, 
					 id_arti      INT,
					 cant_r       NUMERIC(18,4),
					 costo        NUMERIC(18,4),
					 importe      NUMERIC(18,4),
					 id_sub       INT)	
								
		SELECT @operant = -1
		-- ciclo para llenar la tabla de ingredientes
		WHILE 1 = 1
		BEGIN
			SELECT @minoper = MIN(id_operacion) 
			FROM   #operrev
			WHERE  id_operacion > @operant
			
			IF @minoper IS NULL
				BREAK
				
			SELECT @revertido   = id_revertido 
			FROM   #operrev 
			WHERE  id_operacion = @minoper
			
			INSERT  #ingredrev 
			   EXECUTE GetLineasElaboracion @revertido
			
			SELECT @operant = @minoper
			
			CONTINUE				
		END
		
		-- rversion de elaborados
		SELECT @Cad  = 'INSERT #invactual 
						SELECT NULL, 
						       smay.id_secc, 
						       smay.id_arti,
							   cod_arti  = arti.FullArtiCode, 
							   desc_arti = arti.descripcion,
							   cantidad  = COALESCE(ROUND(-smay.cant_r / arti.cant_unme_se, 4), 0),
							   importe   = COALESCE(-smay.importe, 0.00),
							   id_dmov   = 162, 
							   oper.fec_oper,  
							   id_unme   = id_unme_al,
							   cant_um   = cant_unme_al
						FROM       STOKEELO smay 
						INNER JOIN STOKOPER rvtda ON rvtda.id_operacion = smay.ID_OPERACION
						INNER JOIN #OPERREV oper  ON oper.ID_revertido = rvtda.id_operacion
						INNER JOIN STOKARTI arti  ON arti.id_arti = smay.id_arti
						WHERE 1 = 1 '  +  @filtro_arti + @filtro_destino_elab
		EXECUTE (@CAD)     
		-- ingredientes
		SELECT @Cad  = 'INSERT #invactual 
						SELECT NULL, 
						       smay.id_secc, 
						       desl.id_arti,
							   cod_arti  = arti.FullArtiCode, 
							   desc_arti = arti.descripcion,
							   cantidad  = COALESCE(ROUND(-desl.cant_r / arti.cant_unme_se, 4), 0),
							   importe   = COALESCE(-desl.importe, 0.00),
							   id_dmov   = 161, 
							   oper.fec_oper,  
							   id_unme   = id_unme_al,
							   cant_um   = cant_unme_al
						FROM       stokeelo   smay
						INNER JOIN STOKOPER   rvtda ON rvtda.id_operacion = smay.ID_OPERACION
						INNER JOIN #OPERREV   oper  ON oper.ID_revertido = rvtda.id_operacion
						INNER JOIN #ingredrev desl  ON desl.id_operacion = smay.id_operacion
						INNER JOIN STOKARTI   arti  ON arti.id_arti = desl.id_arti
						WHERE 1 = 1 '  +  @filtro_arti + @filtro_destino_elab
		EXECUTE (@CAD)
		
		DROP TABLE #ingredrev
		
	END		
	
	-- hay revers de elaboraciones
	
	DROP TABLE #operrev	
	
	-- temporal de revers de elaboraciones

	-- Eliminar del temporal, los registros segun parmetros de fecha si alguno
	-- de ellos no es nulo. Si ambos son nulos se toma todo.
	-- No lo meto en las selects de arriba por miedo a que se pase de las 8000 char
	-- si hay lista de artis y secciones
	IF @fdesde IS NOT NULL OR @fhasta IS NOT NULL
		DELETE FROM #invactual
		WHERE NOT (
	 				(    @FDESDE IS NULL 
	 				 AND @FHASTA IS NOT NULL 
	 				 AND FEC_OPER <= @FHASTA) 
	 		  OR
	 		  	  (    @FDESDE IS NOT NULL 
	 		  	   AND @FHASTA IS NULL 
	 		  	   AND FEC_OPER >= @FDESDE) 
	 		  OR
	 		  	  (    @FDESDE IS NOT NULL 
	 		  	   AND @FHASTA IS NOT NULL 
	 		  	   AND FEC_OPER BETWEEN @FDESDE AND @FHASTA)
				  )

	-- Meterle los consumos a los registros, 
	-- para cada articulo y alma y secc de las listas
	-- o para todos si las listas estan vacias
	INSERT #consumos 
			(id_arti, 
			 cons_cant, 
			 cons_imp)
 	SELECT DISTINCT id_arti, 0.0000, 0.00
	FROM   #invactual
	
	DECLARE @minarti INT, 
	        @cant    NUMERIC(18,4), 
	        @imp     NUMERIC(18,2),
	        @minant  INT
	        
	SELECT  @minarti = MIN(id_arti) FROM #consumos
	
	-- ciclo para cada articulo
	WHILE @minarti IS NOT NULL
	BEGIN
		--EXECUTE dbo.ConsTotQI @minarti, @fdesde, @fhasta, @list_alma, @list_secc, @cant OUTPUT, @imp OUTPUT 
		
		EXECUTE dbo.ConsTotQI @minarti, 
		        @fdesde, @fhasta, 
		        NULL, NULL, 
		        @cant OUTPUT, @imp OUTPUT 
		
		UPDATE  #consumos 
		SET cons_cant = @cant,
		    cons_imp  = @imp
		WHERE id_arti=@minarti
		
		SELECT @minant  = @minarti
		SELECT @minarti = MIN(id_arti) 
		   FROM #consumos 
		   WHERE id_arti > @minant
		
	END

	-- Si parametro consumo=1, eliminar de invactual los articulos
	-- que tengan consumo cero
	IF @consumo = 1
		DELETE #invactual 
		FROM       #invactual i 
		INNER JOIN #consumos  c ON i.id_arti = c.id_arti
		WHERE  cons_cant = 0 
		   AND cons_imp = 0

	-- Buscar saldos anteriores
	DECLARE @saldo_cant NUMERIC(18,4),
	        @saldo_imp NUMERIC(18,2),
	        @garti INT
	        
 	DECLARE guia CURSOR FOR
   	SELECT DISTINCT id_arti FROM #invactual 
   	
 	OPEN guia
 	
 	FETCH NEXT FROM guia INTO @garti
 	
	WHILE @@FETCH_STATUS=0 
	BEGIN
		IF @fdesde IS NOT NULL 
			BEGIN
				--EXECUTE dbo.SaldosAntTot @garti, @fdesde, @list_alma, @list_secc, @saldo_cant OUTPUT, @saldo_imp OUTPUT 
				
				EXECUTE dbo.SaldosAntTot 
				        @garti, @fdesde, 
				        NULL, NULL, 
				        @saldo_cant OUTPUT, @saldo_imp OUTPUT 
			END
		ELSE
			SELECT @saldo_cant = 0,
			       @saldo_imp  = 0
			       
		    INSERT #saldosant 
					(id_arti,
					 sant_cantidad,
					 sant_importe)
			VALUES (@garti, @saldo_cant, @saldo_imp)
 	 	FETCH NEXT FROM guia INTO @garti
   	END
 	CLOSE guia
 	DEALLOCATE guia

    SELECT su.*, 
		   cod_unme   = unme.codigo, 
		   desc_unme  = unme.descripcion,
		   existencia = (COALESCE(dbo.ExistenciaEnAlmacen(su.id_arti, /*@list_alma*/ NULL), 0) 
		                + COALESCE(dbo.ExistenciaEnSeccion(su.id_arti, /*@list_secc*/ NULL), 0))
		                 / cant_unme_se,
		   imp_actual =  COALESCE(dbo.ImporteEnAlmacen(su.id_arti, /*@list_alma*/ NULL), 0)
		                 + COALESCE(dbo.ImporteEnSeccion(su.id_arti, /*@list_secc*/ NULL), 0),
		   cod_dmov   = dmov.codigo, 
		   desc_dmov  = dmov.descripcion,
		   cod_fami   = fami.codigo, 
		   desc_fami  = fami.descripcion,
		   cod_grup   = grup.codigo, 
		   desc_grup  = grup.descripcion,
		   sant_cantidad = COALESCE(sant_cantidad, 0.0000),
		   sant_importe  = COALESCE(sant_importe, 0.00),
		   cons_cant / cant_unme_se as cons_cant,
		   cons_imp
	INTO       #Consumos2
	FROM       #invactual su
    INNER JOIN stokunme   unme ON su.id_unme = unme.id_unme
    INNER JOIN stokdmov   dmov ON su.id_dmov = dmov.id_dmov
	INNER JOIN stokarti   arti ON su.id_arti = arti.id_arti
	INNER JOIN stokfami   fami ON arti.id_fami = fami.id_fami
	INNER JOIN stokgrup   grup ON fami.id_grup = grup.id_grup
	INNER JOIN #saldosant sant ON su.id_arti = sant.id_arti 
	INNER JOIN #consumos  cons ON su.id_arti = cons.id_arti 
	ORDER BY   cod_arti
	
	DECLARE @FechaInven DATE = (SELECT fecha_dia FROM STOKTABL WHERE id_tabl = 1)
	
	--DECLARE @DiasExist  INT  = DATEDIFF(DAY, @FechaInven, GETDATE())
	DECLARE @DiasExist  INT  = DATEDIFF(DAY, @fdesde, @fhasta)
	
	SELECT MAX(cod_grup) AS cod_grup,
	       MAX(cod_fami) AS cod_fami,
	       MAX(cod_grup) + ' - ' + MAX(desc_grup) AS desc_grup,
	       MAX(cod_fami) + ' - ' + MAX(desc_fami) AS desc_fami,
	       MAX(id_arti) AS id_arti,
		   MAX(cod_arti) AS cod_arti,
	       MAX(desc_arti) AS desc_arti,
	       MAX(cod_unme) AS cod_unme,
	       MAX(sant_cantidad) AS sant_cantidad,
	       MAX(sant_importe) AS sant_importe,
	       SUM(CASE id_dmov 
	                WHEN 0   THEN cantidad 
                    WHEN 1   THEN cantidad
                    WHEN 2   THEN cantidad
                    WHEN 32  THEN cantidad
                    WHEN 320 THEN cantidad
                    WHEN 42  THEN cantidad 
                    WHEN 5   THEN cantidad
                    WHEN 6   THEN cantidad
                    WHEN 9   THEN cantidad
                    WHEN 72  THEN cantidad 
                    WHEN 102 THEN cantidad
                    WHEN 112 THEN cantidad
                    WHEN 131 THEN cantidad
                    WHEN 142 THEN cantidad
                    WHEN 152 THEN cantidad
                    WHEN 162 THEN cantidad 
                    ELSE 0 
                    END) AS EntAumCantidad,
	       SUM(CASE id_dmov 
					WHEN 0   THEN importe 
                    WHEN 1   THEN importe
                    WHEN 2   THEN importe
                    WHEN 32  THEN importe
                    WHEN 320 THEN importe
                    WHEN 42  THEN importe 
                    WHEN 5   THEN importe
                    WHEN 6   THEN importe
                    WHEN 9   THEN importe
                    WHEN 72  THEN importe 
                    WHEN 102 THEN importe
                    WHEN 112 THEN importe
                    WHEN 131 THEN importe
                    WHEN 142 THEN importe
                    WHEN 152 THEN importe
                    WHEN 162 THEN importe 
                    ELSE 0 
                    END) AS EntAumImporte,
	       MAX(ISNULL(cons_cant, 0)) AS cons_cant,
	       MAX(ISNULL(cons_imp, 0))  AS cons_imp,
	       SUM(CASE id_dmov 
	                WHEN 31  THEN cantidad 
                    WHEN 41  THEN cantidad 
                    WHEN 71  THEN cantidad 
                    WHEN 132 THEN cantidad 
                    WHEN 141 THEN cantidad 
                    WHEN 101 THEN cantidad
                    WHEN 111 THEN cantidad
                    WHEN 151 THEN cantidad
                    WHEN 161 THEN cantidad 
                    ELSE 0 
                    END) AS DismiCantidad,
	       SUM(CASE id_dmov 
	                WHEN 31  THEN importe 
					WHEN 41  THEN importe 
					WHEN 71  THEN importe 
					WHEN 132 THEN importe 
					WHEN 141 THEN importe 
					WHEN 101 THEN importe
					WHEN 111 THEN importe
					WHEN 151 THEN importe
					WHEN 161 THEN importe 
					ELSE 0 
					END) AS DismiImporte,
	       MAX(ISNULL(sant_cantidad, 0)) - MAX(ISNULL(cons_cant, 0))
	       +
	       SUM(CASE id_dmov 
	                WHEN 0   THEN cantidad 
                    WHEN 1   THEN cantidad
                    WHEN 2   THEN cantidad
                    WHEN 32  THEN cantidad
                    WHEN 320 THEN cantidad
                    WHEN 42  THEN cantidad 
                    WHEN 5   THEN cantidad
                    WHEN 6   THEN cantidad
                    WHEN 9   THEN cantidad
                    WHEN 72  THEN cantidad 
                    WHEN 102 THEN cantidad
                    WHEN 112 THEN cantidad
                    WHEN 131 THEN cantidad
                    WHEN 142 THEN cantidad
                    WHEN 152 THEN cantidad
                    WHEN 162 THEN cantidad 
                    ELSE 0 
                    END)
	       -
	       SUM(CASE id_dmov 
	                WHEN 31  THEN cantidad 
                    WHEN 41  THEN cantidad 
                    WHEN 71  THEN cantidad 
                    WHEN 132 THEN cantidad 
                    WHEN 141 THEN cantidad 
                    WHEN 101 THEN cantidad
                    WHEN 111 THEN cantidad
                    WHEN 151 THEN cantidad
                    WHEN 161 THEN cantidad 
                    ELSE 0 
                    END) AS InvenFinalCantidad,
	       MAX(ISNULL(sant_importe, 0)) - MAX(ISNULL(cons_imp, 0))
	       +
	       SUM(CASE id_dmov 
					WHEN 0   THEN importe 
					WHEN 1   THEN importe
					WHEN 2   THEN importe
					WHEN 32  THEN importe
					WHEN 320 THEN importe
					WHEN 42  THEN importe 
					WHEN 5   THEN importe
					WHEN 6   THEN importe
					WHEN 9   THEN importe
					WHEN 72  THEN importe 
					WHEN 102 THEN importe
					WHEN 112 THEN importe
					WHEN 131 THEN importe
					WHEN 142 THEN importe
					WHEN 152 THEN importe
					WHEN 162 THEN importe 
					ELSE 0 
					END)
	       -
	       SUM(CASE id_dmov 
					WHEN 31  THEN importe 
					WHEN 41  THEN importe 
					WHEN 71  THEN importe 
					WHEN 132 THEN importe 
					WHEN 141 THEN importe 
					WHEN 101 THEN importe
					WHEN 111 THEN importe
					WHEN 151 THEN importe
					WHEN 161 THEN importe 
					ELSE 0 
					END) AS InvenFinalImporte,
	       MAX(existencia) AS existencia,
	       MAX(imp_actual) AS imp_actual,
	       CASE @DiasExist WHEN 0 
	                       THEN 0
			               ELSE MAX(ISNULL(cons_cant, 0)) / @DiasExist
			               END AS ConsDiarCant,
		   CASE @DiasExist WHEN 0 
		                   THEN 0
			               ELSE MAX(ISNULL(cons_imp, 0)) / @DiasExist
			               END AS ConsDiarImp,
		   CASE @DiasExist WHEN 0 
		                   THEN 0
				           ELSE CASE MAX(ISNULL(cons_cant, 0)) / @DiasExist 
				                     WHEN 0 
				                     THEN 0
				                     ELSE MAX(ISNULL(existencia, 0)) 
				                          / (MAX(ISNULL(cons_cant, 0))
				                          / @DiasExist) END
		   END AS DiasExist,
		   @fdesde AS FecIni,
		   @fhasta AS FecFin,
		   @FechaInven AS FechaInven 
	FROM   #Consumos2
	GROUP BY id_arti
	ORDER BY cod_grup, cod_fami, cod_arti
 
    DROP TABLE #invactual
    DROP TABLE #saldosant
    DROP TABLE #consumos
    
    DROP TABLE #Consumos2

END

