-- Predeterminado / Cuenta de Ingreso (Totalizado, solo si hay Conta) / + Vendidos

SELECT  hfac.id_mone,
        hfac.id_pvta, 
        Pvta.cod_pvta,
        Pvta.desc_pvta,
        hfad.id_fami,
        hfad.desc_fami,
        hfac.cod_mone,
        hfac.desc_mone, 
        enfa.id_cta_con1, 
        conc_ingreso = con1.desc_con1,
        tasa_inv     = dbo.lnk_Get_Tasa_Mone_Inv(hfac.id_mone), 
        vbrutas      = ABS(ROUND( Sum(dbo.Get_Importe_Bruto_Hist_Contable(hfad.id_fali) * hfad.cantidad), 2)), 
        vnetas       = ABS(ROUND( Sum( hfal.importe_neto_cont * hfad.cantidad ), 2)), 
        dcto         = ABS(ROUND( SUM( hfal.dcto_noccasa * hfad.cantidad ), 2)), 
        recargo      = ABS(ROUND( SUM( hfal.recargo_noccasa * hfad.cantidad ), 2)), 
        vcosto       = ABS(ROUND( Sum( hfad.precio_costo * hfad.cantidad), 2)),	
        impu_vent    = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,1) * hfad.cantidad ),2)),
        impu_serv    = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,2) * hfad.cantidad ),2)),
        tax3         = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,3) * hfad.cantidad ),2)),
        tax4         = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,4) * hfad.cantidad ),2)),
        tax5         = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,5) * hfad.cantidad ),2)),
        tax6         = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,6) * hfad.cantidad ),2)),
        factor_impu  = ROUND(1 + (dbo.Calc_Impu_Enfa_Tot_NoExentos(hfad.id_enfa,hfac.id_exen) / 100), 2),
        ccasa        = 0 , 
        hfac.id_moau	
From       VRESTHFAD hfad 
INNER JOIN RESTHFAL  hfal  on hfad.id_fali = hfal.id_fali 
INNER JOIN VRESTHFAC hfac  ON hfal.id_fact = hfac.id_fact 
INNER JOIN RestPvta  Pvta  ON HFac.id_pvta = pvta.id_pvta 
INNER JOIN RESTENFA  enfa  on hfad.id_enfa = enfa.id_enfa 
INNER JOIN HOTECON1  con1  on enfa.id_cta_con1 = con1.id_con1 
Where hfac.estado = 4 and 
      dbo.Es_CtaCasa_Hist(hfac.id_fact)  = 0  
Group by hfad.id_fami,   hfac.id_pvta, pvta.cod_pvta,  pvta.desc_pvta, 
         hfad.desc_fami, hfac.id_moau, cod_mone,       enfa.id_cta_con1, 
         con1.desc_con1, hfac.id_mone, hfac.desc_mone, hfad.id_enfa,
         hfac.id_exen 
Order by hfac.id_mone, Pvta.cod_pvta, con1.desc_con1, desc_fami

-- Predeterminado / Familia (Resumido) / + Vendidos

SELECT  hfac.id_mone,
        hfac.id_pvta, 
        Pvta.cod_pvta,
        Pvta.desc_pvta,
        hfad.id_fami,
        hfad.desc_fami,
        hfac.cod_mone,
        hfac.desc_mone, 
        tasa_inv = dbo.lnk_Get_Tasa_Mone_Inv(hfac.id_mone), 
        vbrutas     = ABS(ROUND( Sum( dbo.Get_Importe_Bruto_Hist_Contable(hfad.id_fali) * hfad.cantidad ), 2)), 
        vnetas      = ABS(ROUND( Sum( hfal.importe_neto_cont * hfad.cantidad ), 2)), 
        dcto        = ABS(ROUND( SUM( hfal.dcto_noccasa * hfad.cantidad ), 2)), 
        recargo     = ABS(ROUND( SUM( hfal.recargo_noccasa * hfad.cantidad ), 2)), 
        vcosto      = ABS(ROUND( Sum( hfad.precio_costo * hfad.cantidad), 2)),	
        impu_vent   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,1) * hfad.cantidad ),2)),
        impu_serv   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,2) * hfad.cantidad ),2)),
        tax3        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,3) * hfad.cantidad ),2)),
        tax4        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,4) * hfad.cantidad ),2)),
        tax5        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,5) * hfad.cantidad ),2)),
        tax6        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,6) * hfad.cantidad ),2)),
        factor_impu = ROUND(1 + (dbo.Calc_Impu_Enfa_Tot_NoExentos(hfad.id_enfa,hfac.id_exen) / 100), 2),
        ccasa       = 0 , 
        hfac.id_moau	
From       VRESTHFAD hfad 
INNER JOIN RESTHFAL  hfal on hfad.id_fali = hfal.id_fali 
INNER JOIN VRESTHFAC hfac ON hfal.id_fact = hfac.id_fact 
INNER JOIN RestPvta  Pvta ON HFac.id_pvta = pvta.id_pvta 
Where      hfac.estado = 4 and 
           dbo.Es_CtaCasa_Hist(hfac.id_fact)  = 0  
Group by   hfad.id_fami,   hfac.id_pvta, pvta.cod_pvta, pvta.desc_pvta, 
           hfad.desc_fami, hfac.id_moau, cod_mone,      hfac.id_mone, 
           hfac.desc_mone, hfad.id_enfa, hfac.id_exen 
Order by   hfac.id_mone, Pvta.cod_pvta, desc_fami

-- Predeterminado / Artculos (Detallado) / + Vendidos

SELECT hfac.id_mone,
       hfac.id_pvta, 
       Pvta.cod_pvta,
       Pvta.desc_pvta,
       hfad.id_arti,
       hfad.cod_arti,
       hfad.desc_arti,
       hfac.cod_mone,
       hfac.desc_mone, 
       cantidad    = Sum(hfad.cantidad), --****
       tasa_inv    = dbo.lnk_Get_Tasa_Mone_Inv(hfac.id_mone), 
       vbrutas     = ABS(ROUND( Sum( dbo.Get_Importe_Bruto_Hist_Contable(hfad.id_fali) * hfad.cantidad ), 2)), 
       vnetas      = ABS(ROUND( Sum( hfal.importe_neto_cont * hfad.cantidad ), 2)), 
       dcto        = ABS(ROUND( SUM( hfal.dcto_noccasa * hfad.cantidad ), 2)), 
       recargo     = ABS(ROUND( SUM( hfal.recargo_noccasa * hfad.cantidad ), 2)), 
       vcosto      = ABS(ROUND( Sum( hfad.precio_costo * hfad.cantidad), 2)),	
       impu_vent   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,1) * hfad.cantidad ),2)),
       impu_serv   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,2) * hfad.cantidad ),2)),
       tax3        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,3) * hfad.cantidad ),2)),
       tax4        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,4) * hfad.cantidad ),2)),
       tax5        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,5) * hfad.cantidad ),2)),
       tax6        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,6) * hfad.cantidad ),2)),
       factor_impu = ROUND(1 + (dbo.Calc_Impu_Enfa_Tot_NoExentos(hfad.id_enfa,hfac.id_exen) / 100), 2),
       ccasa       = 0 , 
       hfac.id_moau	
From       VRESTHFAD hfad 
INNER JOIN RESTHFAL  hfal on hfad.id_fali = hfal.id_fali 
INNER JOIN VRESTHFAC hfac ON hfal.id_fact = hfac.id_fact 
INNER JOIN RestPvta  Pvta ON HFac.id_pvta = pvta.id_pvta 
Where hfac.estado = 4  and 
      dbo.Es_CtaCasa_Hist(hfac.id_fact) = 0  
Group by hfad.id_arti,  hfac.id_pvta,   pvta.cod_pvta, pvta.desc_pvta, 
         hfad.cod_arti, hfad.desc_arti, hfac.id_moau,  hfac.cod_mone, 
         hfac.id_mone,  hfac.desc_mone, hfad.id_enfa,  hfac.id_exen 
Order by hfac.id_mone,  hfad.cod_arti,  Pvta.cod_pvta

-- Predeterminado / Cuenta Casa / + Vendidos

SELECT  Credito = dbo.Get_Refer_Cobro(TCob.id_fpag, hfco.id_line_cline, hfco.id_dato),
        hfac.id_pvta, 
        Pvta.cod_pvta,
        Pvta.desc_pvta,
        hfad.id_fami,
        hfad.desc_fami,
        tasa_inv    = dbo.lnk_Get_Tasa_Mone_Inv(hfac.id_mone), 
        vbrutas     = ABS(ROUND( Sum( dbo.Get_Importe_Bruto_Hist_Contable(hfad.id_fali) * hfad.cantidad), 2)), 
        vnetas      = ABS(ROUND( Sum( hfal.importe_neto_cont * hfad.cantidad ), 2)), 
        dcto        = ABS(ROUND( SUM( hfal.dcto_neto    * hfad.cantidad ), 2)), 
        recargo     = ABS(ROUND( SUM( hfal.recargo_neto * hfad.cantidad ), 2)), 
        vcosto      = ABS(ROUND( Sum( hfad.precio_costo * hfad.cantidad ), 2)),	
        impu_vent   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,1) * hfad.cantidad ),2)),
        impu_serv   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,2) * hfad.cantidad ),2)),
        tax3        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,3) * hfad.cantidad ),2)),
        tax4        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,4) * hfad.cantidad ),2)),
        tax5        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,5) * hfad.cantidad ),2)),
        tax6        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,6) * hfad.cantidad ),2)),
        factor_impu = ROUND(1 + (dbo.Calc_Impu_Enfa_Tot_NoExentos(hfad.id_enfa,hfac.id_exen) / 100), 2),
        ccasa       = ABS(ROUND( Sum( hfal.importe_neto_cont * hfad.cantidad ), 2)) 
FROM RESTHFCO hfco 
INNER JOIN RestTcob  Tcob ON hfco.id_tcob = tcob.id_tcob 
INNER JOIN RESTHFAL  hfal ON hfco.id_fact = hfal.id_fact 
INNER JOIN VRESTHFAD hfad ON hfal.id_fali = hfad.id_fali 
INNER JOIN VRESTHFAC hfac ON hfal.id_fact = hfac.id_fact 
INNER JOIN RestPvta Pvta  ON HFac.id_pvta = pvta.id_pvta, 
           RestTabl Tabl 
WHERE hfac.Estado = 4 and 
      dbo.Es_CtaCasa_Hist(hfac.id_fact)  = 1 and 
      Tcob.id_fpag = 5 and 
      tcob.cuenta_casa = 1  
Group by dbo.Get_Refer_Cobro(TCob.id_fpag, hfco.id_line_cline, hfco.id_dato), 
         hfad.id_fami, hfac.id_pvta,   pvta.cod_pvta, pvta.desc_pvta,
         hfac.id_mone, hfad.desc_fami, hfad.id_enfa,  hfac.id_exen 
Order by credito,Pvta.cod_pvta,hfad.desc_fami

-- Familias / Escogiendo PV y Fecha

SELECT  hfac.id_mone,
        hfac.id_pvta, 
        Pvta.cod_pvta,
        Pvta.desc_pvta,
        hfad.id_fami,
        hfad.desc_fami,
        hfac.cod_mone,
        hfac.desc_mone, 
        tasa_inv = dbo.lnk_Get_Tasa_Mone_Inv(hfac.id_mone), 
        vbrutas     = ABS(ROUND( Sum( dbo.Get_Importe_Bruto_Hist_Contable(hfad.id_fali) * hfad.cantidad ), 2)), 
        vnetas      = ABS(ROUND( Sum( hfal.importe_neto_cont * hfad.cantidad ), 2)), 
        dcto        = ABS(ROUND( SUM( hfal.dcto_noccasa * hfad.cantidad ), 2)), 
        recargo     = ABS(ROUND( SUM( hfal.recargo_noccasa * hfad.cantidad ), 2)), 
        vcosto      = ABS(ROUND( Sum( hfad.precio_costo * hfad.cantidad), 2)),	
        impu_vent   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,1) * hfad.cantidad ),2)),
        impu_serv   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,2) * hfad.cantidad ),2)),
        tax3        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,3) * hfad.cantidad ),2)),
        tax4        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,4) * hfad.cantidad ),2)),
        tax5        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,5) * hfad.cantidad ),2)),
        tax6        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,6) * hfad.cantidad ),2)),
        factor_impu = ROUND(1 + (dbo.Calc_Impu_Enfa_Tot_NoExentos(hfad.id_enfa,hfac.id_exen) / 100), 2),
        ccasa       = 0 , 
        hfac.id_moau	
From       VRESTHFAD hfad 
INNER JOIN RESTHFAL  hfal  on hfad.id_fali = hfal.id_fali 
INNER JOIN VRESTHFAC hfac  ON hfal.id_fact = hfac.id_fact 
INNER JOIN RestPvta  Pvta  ON HFac.id_pvta = pvta.id_pvta 
INNER JOIN RestTurn  Turn  ON hfac.id_turn = turn.id_turn 
Where hfac.estado = 4 and 
      dbo.Es_CtaCasa_Hist(hfac.id_fact)  = 0  
      and hfac.id_pvta = 5 
      and (Turn.id_turn is null or (Datediff(day,'2012-09-01 00:00:00' ,turn.fecha_ini) >=0  and DateDiff(day,'2012-11-26 23:59:59' ,turn.fecha_ini) <=0) )  
Group by hfad.id_fami,   hfac.id_pvta, pvta.cod_pvta, pvta.desc_pvta, 
         hfad.desc_fami, hfac.id_moau, cod_mone,      hfac.id_mone, 
         hfac.desc_mone, hfad.id_enfa, hfac.id_exen 
Order by hfac.id_mone,   desc_fami,    Pvta.cod_pvta

-- Cuenta de Ingreso / Escogiendo PV y Fechas

SELECT  hfac.id_mone,
        hfac.id_pvta, 
        Pvta.cod_pvta,
        Pvta.desc_pvta,
        hfad.id_fami,
        hfad.desc_fami,
        hfac.cod_mone,
        hfac.desc_mone, 
        enfa.id_cta_con1, 
        conc_ingreso = con1.desc_con1,
        tasa_inv    = dbo.lnk_Get_Tasa_Mone_Inv(hfac.id_mone), 
        vbrutas     = ABS(ROUND( Sum( dbo.Get_Importe_Bruto_Hist_Contable(hfad.id_fali) * hfad.cantidad), 2)), 
        vnetas      = ABS(ROUND( Sum( hfal.importe_neto_cont * hfad.cantidad ), 2)), 
        dcto        = ABS(ROUND( SUM( hfal.dcto_noccasa * hfad.cantidad ), 2)), 
        recargo     = ABS(ROUND( SUM( hfal.recargo_noccasa * hfad.cantidad ), 2)), 
        vcosto      = ABS(ROUND( Sum( hfad.precio_costo * hfad.cantidad), 2)),	
        impu_vent   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,1) * hfad.cantidad ),2)),
        impu_serv   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,2) * hfad.cantidad ),2)),
        tax3        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,3) * hfad.cantidad ),2)),
        tax4        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,4) * hfad.cantidad ),2)),
        tax5        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,5) * hfad.cantidad ),2)),
        tax6        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,6) * hfad.cantidad ),2)),
        factor_impu = ROUND(1 + (dbo.Calc_Impu_Enfa_Tot_NoExentos(hfad.id_enfa,hfac.id_exen) / 100), 2),
        ccasa       = 0 , 
        hfac.id_moau	
From       VRESTHFAD hfad 
INNER JOIN RESTHFAL hfal  on hfad.id_fali = hfal.id_fali 
INNER JOIN VRESTHFAC hfac ON hfal.id_fact = hfac.id_fact 
INNER JOIN RestPvta Pvta ON HFac.id_pvta = pvta.id_pvta 
INNER JOIN RESTENFA enfa on hfad.id_enfa = enfa.id_enfa 
INNER JOIN HOTECON1 con1 on enfa.id_cta_con1 = con1.id_con1 
INNER JOIN RestTurn Turn ON hfac.id_turn = turn.id_turn 
Where hfac.estado = 4 and 
      dbo.Es_CtaCasa_Hist(hfac.id_fact)  = 0  and 
      hfac.id_pvta = 5 and 
      ( Turn.id_turn is null or (Datediff(day,'2012-09-01 00:00:00' ,turn.fecha_ini) >=0  and DateDiff(day,'2012-11-26 23:59:59' ,turn.fecha_ini) <=0) )  
Group by hfad.id_fami,   hfac.id_pvta, pvta.cod_pvta,  pvta.desc_pvta, 
         hfad.desc_fami, hfac.id_moau, cod_mone,       enfa.id_cta_con1, 
         con1.desc_con1, hfac.id_mone, hfac.desc_mone, hfad.id_enfa,
         hfac.id_exen 
Order by hfac.id_mone, con1.desc_con1, desc_fami, Pvta.cod_pvta

-- Artculos, Escogiendo PV y Fechas, Los 15 Menos Vendidos

set language english

SELECT TOP 15 hfac.id_mone,
              hfac.id_pvta, 
              Pvta.cod_pvta,
              Pvta.desc_pvta,
              arti.id_arti,
              arti.cod_arti,
              arti.desc_arti,
              hfac.cod_mone,
              hfac.desc_mone, 
              cantidad = Sum(hfad.cantidad),
              tasa_inv    = dbo.lnk_Get_Tasa_Mone_Inv(hfac.id_mone), 
              vbrutas     = ABS(ROUND( Sum( dbo.Get_Importe_Bruto_Hist_Contable(hfad.id_fali) * hfad.cantidad ), 2)), 
              vnetas      = ABS(ROUND( Sum( hfal.importe_neto_cont * hfad.cantidad ), 2)), 
              dcto        = ABS(ROUND( SUM( hfal.dcto_noccasa * hfad.cantidad ), 2)), 
              recargo     = ABS(ROUND( SUM( hfal.recargo_noccasa * hfad.cantidad ), 2)), 
              vcosto      = ABS(ROUND( Sum( hfad.precio_costo * hfad.cantidad), 2)),	
              impu_vent   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,1) * hfad.cantidad ),2)),
              impu_serv   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,2) * hfad.cantidad ),2)),
              tax3        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,3) * hfad.cantidad ),2)),
              tax4        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,4) * hfad.cantidad ),2)),
              tax5        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,5) * hfad.cantidad ),2)),
              tax6        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,6) * hfad.cantidad ),2)),
              factor_impu = ROUND(1 + (dbo.Calc_Impu_Enfa_Tot_NoExentos(hfad.id_enfa,hfac.id_exen) / 100), 2),
              ccasa       = 0 , hfac.id_moau	
From      RESTARTI  arti 
LEFT JOIN VRESTHFAD hfad on arti.id_arti = hfad.id_arti 
LEFT JOIN RESTHFAL  hfal on hfad.id_fali = hfal.id_fali 
LEFT JOIN VRESTHFAC hfac ON hfal.id_fact = hfac.id_fact 
LEFT JOIN RestPvta  Pvta ON HFac.id_pvta = pvta.id_pvta 
LEFT JOIN RestTurn  Turn ON hfac.id_turn = turn.id_turn 
Where (hfac.id_fact is null or hfac.estado = 4) and   
       arti.id_arti not in (Select id_aral_arti From restescd where sub_esc = 1)  and 
       arti.eliminado = 0  and 
       dbo.Es_CtaCasa_Hist(hfac.id_fact) = 0  and 
       hfac.id_pvta = 5 and 
       ( Turn.id_turn is null or (Datediff(day,'2012-09-01 00:00:00' ,turn.fecha_ini) >=0  and DateDiff(day,'2012-11-26 23:59:59' ,turn.fecha_ini) <=0) )  
Group by arti.id_arti,  hfac.id_pvta,   pvta.cod_pvta, pvta.desc_pvta, 
         arti.cod_arti, arti.desc_arti, hfac.id_moau,  hfac.cod_mone, 
         hfac.id_mone,  hfac.desc_mone, hfad.id_enfa,  hfac.id_exen 
Order by hfac.id_mone,  cantidad ASC,   arti.cod_arti, Pvta.cod_pvta

-- Artculos, Escogiendo PV y Fechas, Los 15 Ms Vendidos

SELECT TOP 15 hfac.id_mone,
              hfac.id_pvta, 
              Pvta.cod_pvta,
              Pvta.desc_pvta,
              hfad.id_arti,
              hfad.cod_arti,
              hfad.desc_arti,
              hfac.cod_mone,
              hfac.desc_mone, 
              cantidad = Sum(hfad.cantidad),tasa_inv    = dbo.lnk_Get_Tasa_Mone_Inv(hfac.id_mone), 
              vbrutas     = ABS(ROUND( Sum( dbo.Get_Importe_Bruto_Hist_Contable(hfad.id_fali) * hfad.cantidad ), 2)), 
              vnetas      = ABS(ROUND( Sum( hfal.importe_neto_cont * hfad.cantidad ), 2)), 
              dcto        = ABS(ROUND( SUM( hfal.dcto_noccasa * hfad.cantidad ), 2)), 
              recargo     = ABS(ROUND( SUM( hfal.recargo_noccasa * hfad.cantidad ), 2)), 
              vcosto      = ABS(ROUND( Sum( hfad.precio_costo * hfad.cantidad), 2)),	
              impu_vent   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,1) * hfad.cantidad ),2)),
              impu_serv   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,2) * hfad.cantidad ),2)),
              tax3        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,3) * hfad.cantidad ),2)),
              tax4        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,4) * hfad.cantidad ),2)),
              tax5        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,5) * hfad.cantidad ),2)),
              tax6        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,6) * hfad.cantidad ),2)),
              factor_impu = ROUND(1 + (dbo.Calc_Impu_Enfa_Tot_NoExentos(hfad.id_enfa,hfac.id_exen) / 100), 2),
              ccasa       = 0 , hfac.id_moau	
From       VRESTHFAD hfad 
INNER JOIN RESTHFAL  hfal on hfad.id_fali = hfal.id_fali 
INNER JOIN VRESTHFAC hfac ON hfal.id_fact = hfac.id_fact 
INNER JOIN RestPvta  Pvta ON HFac.id_pvta = pvta.id_pvta 
INNER JOIN RestTurn  Turn ON hfac.id_turn = turn.id_turn 
Where hfac.estado = 4  and 
      dbo.Es_CtaCasa_Hist(hfac.id_fact) = 0  and 
      hfac.id_pvta = 5 and 
      Datediff(day,'2012-09-01 00:00:00' ,turn.fecha_ini) >=0  and 
      DateDiff(day,'2012-11-26 23:59:59' ,turn.fecha_ini) <=0  
Group by hfad.id_arti,  hfac.id_pvta,   pvta.cod_pvta, pvta.desc_pvta, 
         hfad.cod_arti, hfad.desc_arti, hfac.id_moau,  hfac.cod_mone, 
         hfac.id_mone,  hfac.desc_mone, hfad.id_enfa,  hfac.id_exen 
Order by hfac.id_mone, cantidad DESC, hfad.cod_arti, Pvta.cod_pvta

-- Artculos, Escogiendo PV, Fechas y Familia, Los 15 Ms Vendidos

set language english

SELECT TOP 15 hfac.id_mone,
              hfac.id_pvta, 
              Pvta.cod_pvta,
              Pvta.desc_pvta,
              hfad.id_arti,
              hfad.cod_arti,
              hfad.desc_arti,
              hfac.cod_mone,
              hfac.desc_mone, 
              cantidad = Sum(hfad.cantidad),
              tasa_inv    = dbo.lnk_Get_Tasa_Mone_Inv(hfac.id_mone),
              vbrutas     = ABS(ROUND( Sum( dbo.Get_Importe_Bruto_Hist_Contable(hfad.id_fali) * hfad.cantidad ), 2)), 
              vnetas      = ABS(ROUND( Sum( hfal.importe_neto_cont * hfad.cantidad ), 2)), 
              dcto        = ABS(ROUND( SUM( hfal.dcto_noccasa * hfad.cantidad ), 2)), 
              recargo     = ABS(ROUND( SUM( hfal.recargo_noccasa * hfad.cantidad ), 2)), 
              vcosto      = ABS(ROUND( Sum( hfad.precio_costo * hfad.cantidad), 2)),	
              impu_vent   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,1) * hfad.cantidad ),2)),
              impu_serv   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,2) * hfad.cantidad ),2)),
              tax3        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,3) * hfad.cantidad ),2)),
              tax4        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,4) * hfad.cantidad ),2)),
              tax5        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,5) * hfad.cantidad ),2)),
              tax6        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,6) * hfad.cantidad ),2)),
              factor_impu = ROUND(1 + (dbo.Calc_Impu_Enfa_Tot_NoExentos(hfad.id_enfa,hfac.id_exen) / 100), 2),
              ccasa       = 0 , hfac.id_moau	
From       VRESTHFAD hfad 
INNER JOIN RESTHFAL  hfal on hfad.id_fali = hfal.id_fali 
INNER JOIN VRESTHFAC hfac ON hfal.id_fact = hfac.id_fact 
INNER JOIN RestPvta  Pvta ON HFac.id_pvta = pvta.id_pvta 
INNER JOIN RestTurn  Turn ON hfac.id_turn = turn.id_turn 
Where hfac.estado = 4  and 
      dbo.Es_CtaCasa_Hist(hfac.id_fact) = 0  and 
      hfac.id_pvta = 5 and 
      hfad.id_fami = 36 and 
      Datediff(day,'2012-09-01 00:00:00' ,turn.fecha_ini) >=0  and 
      DateDiff(day,'2012-11-26 23:59:59' ,turn.fecha_ini) <=0  
Group by hfad.id_arti, hfac.id_pvta, pvta.cod_pvta, pvta.desc_pvta, 
         hfad.cod_arti, hfad.desc_arti, hfac.id_moau,hfac.cod_mone, 
         hfac.id_mone, hfac.desc_mone,hfad.id_enfa,hfac.id_exen 
Order by hfac.id_mone, cantidad DESC, hfad.cod_arti, Pvta.cod_pvta